#include "X3D_Loader.h"
#include "X3D_Creator.h"
#include "X3DComponentWalker.h"
#include "X3DComponentVisitor.h"
#include "X3D_Scene.h"

#ifdef XERCES
  #include "X3D_XercesLoader.h"
#endif
#ifdef LIBXML
  #include "X3D_libXMLLoader.h"
#endif
#ifdef QT
  #include "X3D_QLoader.h"
#endif

#include "X3D_FileValidator.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Loader::Loader()
: X3DLoader()
{
  creator = new Creator();
  fileValidator = new X3D::FileValidator();
  
#ifdef XERCES
  xmlLoader = new XercesLoader(creator);
#endif
#ifdef LIBXML
  xmlLoader = new libXMLLoader(creator);
#endif
#ifdef QT
  xmlLoader = new QLoader(creator);
#endif
}

Loader::~Loader()
{
  delete creator;
  delete fileValidator;
  delete xmlLoader;
}

}
}
