#include "X3D_X3DSensorNode.h"

namespace X3DTK {
namespace X3D {

X3DSensorNode::X3DSensorNode()
: X3DChildNode(), _enabled(true)
{
}

X3DSensorNode::X3DSensorNode(const SFBool &enabled)
: X3DChildNode(), _enabled(enabled)
{
}

X3DSensorNode::X3DSensorNode(const X3DSensorNode &N)
: X3DChildNode(), _enabled(N._enabled)
{
}

X3DSensorNode::~X3DSensorNode()
{
}

void X3DSensorNode::setEnabled(const SFBool &enabled)
{
  _enabled = enabled;
}

void X3DSensorNode::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("enabled");
  if (index != -1)
    _enabled = (element->getAttribute(index)).upper() == "TRUE";
}

SFString &X3DSensorNode::write(SFString &output) const
{
  if (!_enabled)
    output += " enabled=\"" + toSFString(_enabled) + "\""; 

  return output;
}

}
}
