#include "X3D_X3DInterpolatorNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

X3DInterpolatorNode::X3DInterpolatorNode()
  : X3DChildNode(),
    _key(MFFloat())
{
  defineTypeName("X3DInterpolatorNode", "Interpolation");
}

X3DInterpolatorNode::X3DInterpolatorNode(const MFFloat &key)
  : X3DChildNode(),
    _key(key)
{
  defineTypeName("X3DInterpolatorNode", "Interpolation");
}

X3DInterpolatorNode::X3DInterpolatorNode(const X3DInterpolatorNode &N)
  : X3DChildNode(N),
    _key(N._key)
{
}

X3DInterpolatorNode::~X3DInterpolatorNode()
{
}

void X3DInterpolatorNode::setKey(const MFFloat &key)
{
  _key = key;
}

void X3DInterpolatorNode::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("key");
  if (index != -1)
    _key = MFFloat(element->getAttribute(index));
}

SFString &X3DInterpolatorNode::write(SFString &output) const
{
  if (!_key.empty())
    output += " key=\"" + toSFString(_key) + "\"";
    
  return output;  
}

}
}
