#include "X3D_FileValidator.h"
#include "X3D_DFSGraphTraversal.h"
#include "X3D_FileValidatorCoreVisitor.h"
#include "X3D_FileValidatorGeometry3DVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

FileValidator::FileValidator()
: X3DFileValidator()
{
  stateVariables = GraphTraversal::getInstanceOf<FileValidatorStateVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new FileValidatorCoreVisitor());
  graphTraversal->setComponentVisitor(new FileValidatorGeometry3DVisitor());
}

FileValidator::~FileValidator()
{
  GraphTraversal::removeInstanceOf<FileValidatorStateVariables>();
  delete graphTraversal;
}

bool FileValidator::validate(SFNode N) const
{
  stateVariables->setValidity(true);
  graphTraversal->traverse(N);
  return stateVariables->getValidity();
}

}
}
